"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AdvertisingIdPlugin = void 0;

var _analyticsReactNative = require("@segment/analytics-react-native");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

class AdvertisingIdPlugin extends _analyticsReactNative.Plugin {
  constructor() {
    super(...arguments);

    _defineProperty(this, "type", _analyticsReactNative.PluginType.enrichment);
  }

  configure(analytics) {
    var _getNativeModule;

    this.analytics = analytics;
    (_getNativeModule = (0, _analyticsReactNative.getNativeModule)('AnalyticsReactNativePluginAdvertisingId')) === null || _getNativeModule === void 0 ? void 0 : _getNativeModule.getAdvertisingId().then(id => {
      if (id === null) {
        analytics.track('LimitAdTrackingEnabled (Google Play Services) is enabled');
      } else {
        this.setContext(id);
      }
    });
  }

  setContext(id) {
    var _this$analytics;

    (_this$analytics = this.analytics) === null || _this$analytics === void 0 ? void 0 : _this$analytics.context.set({
      device: {
        advertisingId: id,
        adTrackingEnabled: true
      }
    });
  }

}

exports.AdvertisingIdPlugin = AdvertisingIdPlugin;
//# sourceMappingURL=AdvertisingIdPlugin.js.map